<template>
  <div v-if="themeName === 'peru'">
    <div class="divider-y">
      <div class="p-6 space-y-4 password-item-container">
        <h4>{{ $t("login_password") }}</h4>
        <div class="flex space-x-2">
          <div class="w-7/12">
            <el-form
              ref="ruleLoginPasswordFormRef"
              label-position="left"
              :model="loginPasswordFormData"
              status-icon
              :rules="loginPasswordRules"
              label-width="180px"
              :validate-on-rule-change="false"
              class="password-peru"
            >
              <el-form-item
                :label="$t('current_password')"
                prop="currentPassword"
              >
                <el-input
                  v-model="loginPasswordFormData.currentPassword"
                  type="password"
                  autocomplete="off"
                  :placeholder="$t('please_enter_your_current_password')"
                />
              </el-form-item>
              <el-form-item :label="$t('new_password')" prop="newPassword">
                <el-input
                  v-model="loginPasswordFormData.newPassword"
                  type="password"
                  autocomplete="off"
                  :placeholder="$t('please_enter_your_new_password')"
                />
              </el-form-item>
              <el-form-item
                :label="$t('confirm_password')"
                prop="confirmPassword"
              >
                <el-input
                  v-model="loginPasswordFormData.confirmPassword"
                  type="password"
                  autocomplete="off"
                  :placeholder="$t('please_confirm_new_password')"
                />
              </el-form-item>
              <el-form-item>
                <el-button
                  :disabled="isLoginPassProccessing"
                  type="primary"
                  round
                  class="w-[120px] h-[32px]"
                  @click="changeLoginPassword(ruleLoginPasswordFormRef)"
                  >{{ $t("submit") }}</el-button
                >
              </el-form-item>
            </el-form>
          </div>
          <div class="w-5/12">
            <ul class="p-4 space-y-2 rounded --text4 font-[400] leading-[16.41px]">
              <h5 class="--text4">{{ $t("SBOKH_password_policy") }}</h5>
              <li>
                -
                {{
                  $t(
                    "password_must_contain_8_or_more_characters_with_a_mix_of_letters_number_and_symbols"
                  )
                }}
              </li>
              <li>
                - {{ $t("new_password_must_not_be_the_same_as_old_password") }}
              </li>
              <li>
                - {{ $t("confirm_password_must_be_the_same_as_new_password") }}
              </li>
            </ul>
          </div>
        </div>
      </div>
      <div
        v-if="isPaymentPasswordSet && isCashPlayer"
        class="space-y-4 p-6 password-item-container"
      >
        <h4>{{ $t("payment_password") }}</h4>
        <div class="flex space-x-2">
          <div class="w-7/12">
            <el-form
              ref="rulePaymentPasswordFormRef"
              label-position="left"
              :model="paymentPasswordFormData"
              status-icon
              :rules="paymentPasswordRules"
              label-width="180px"
              :validate-on-rule-change="false"
              class="password-peru"
            >
              <el-form-item
                :label="$t('current_password')"
                prop="currentPassword"
              >
                <el-input
                  v-model="paymentPasswordFormData.currentPassword"
                  type="password"
                  autocomplete="off"
                  :placeholder="$t('please_enter_your_current_password')"
                />
              </el-form-item>
              <el-form-item :label="$t('new_password')" prop="newPassword">
                <el-input
                  v-model="paymentPasswordFormData.newPassword"
                  type="password"
                  autocomplete="off"
                  :placeholder="$t('please_enter_your_new_password')"
                />
              </el-form-item>
              <el-form-item
                :label="$t('confirm_password')"
                prop="confirmPassword"
              >
                <el-input
                  v-model="paymentPasswordFormData.confirmPassword"
                  type="password"
                  autocomplete="off"
                  :placeholder="$t('please_confirm_new_password')"
                />
              </el-form-item>
              <el-form-item>
                <el-button
                  :disabled="isPaymentPassProccessing"
                  type="primary"
                  round
                  class="w-[120px] h-[32px]"
                  @click="changePaymentPassword(rulePaymentPasswordFormRef)"
                  >{{ $t("submit") }}</el-button
                >
              </el-form-item>
            </el-form>
          </div>
          <div class="w-5/12">
            <ul class="p-4 space-y-2  rounded --text4 font-[400] leading-[16.41px]">
              <h5 class="--text4">{{ $t("SBOKH_password_policy") }}</h5>
              <li>
                -
                {{
                  $t(
                    "payment_password_will_use_to_verify_your_identity_for_any_fund_related_operation_for_account_safety_purposes_please_enter_4_digits"
                  )
                }}
              </li>
              <li>
                - {{ $t("confirm_password_must_be_the_same_as_new_password") }}
              </li>
            </ul>
          </div>
        </div>
      </div>
      <div
        v-if="isLoginNameEnabled"
        class="p-6 space-y-4 password-item-container"
      >
        <h4>{{ $t("update_login_name") }}</h4>
        <div class="flex space-x-2">
          <div class="w-7/12">
            <el-form
              ref="ruleLoginNameFormRef"
              label-position="left"
              :model="loginNameFormData"
              :rules="loginNameRules"
              label-width="180px"
              :validate-on-rule-change="false"
              class="password-peru"
            >
              <el-form-item :label="$t('new_login_name')" prop="newLoginName">
                <el-input
                  v-model="loginNameFormData.newLoginName"
                  autocomplete="off"
                />
              </el-form-item>
              <el-form-item>
                <el-button
                  :disabled="isLoginNameProccessing"
                  type="primary"
                  round
                  class="w-[120px] h-[32px]"
                  @click="changeLoginName(ruleLoginNameFormRef)"
                  >{{ $t("submit") }}</el-button
                >
              </el-form-item>
            </el-form>
          </div>
          <div class="w-5/12">
            <ul class="p-4 space-y-2  rounded --text4 font-[400] leading-[16.41px]">
              <h5 class="--text4">{{ $t("login_name_policy") }}</h5>
              <li>- {{ $t("login_name_policy_1") }}</li>
              <li>- {{ $t("login_name_policy_2") }}</li>
              <li>- {{ $t("login_name_policy_3") }}</li>
            </ul>
          </div>
        </div>
      </div>
    </div>
    <el-dialog
      v-model="centerDialogVisible"
      width="30%"
      align-center
      :show-close="false"
      :title="$t('password_expired')"
    >
      <div class="w-full flex justify-center text-xl mb-2">
        <font-awesome-icon icon="lock" />
      </div>
      <span class="w-full flex justify-center">{{
        $t("please_change_new_password")
      }}</span>
      <template #footer>
        <span class="dialog-footer">
          <el-button
            type="primary"
            class="is-round"
            @click="centerDialogVisible = false"
          >
            {{ $t("okay") }}
          </el-button>
        </span>
      </template>
    </el-dialog>
  </div>
  <div v-else>
    <div class="divider-y">
      <div class="p-6 space-y-4 password-item-container">
        <h4>{{ $t("login_password") }}</h4>
        <div class="flex space-x-2">
          <div class="w-7/12">
            <el-form
              ref="ruleLoginPasswordFormRef"
              label-position="left"
              :model="loginPasswordFormData"
              status-icon
              :rules="loginPasswordRules"
              label-width="150px"
              :validate-on-rule-change="false"
            >
              <el-form-item
                :label="$t('current_password')"
                prop="currentPassword"
              >
                <el-input
                  v-model="loginPasswordFormData.currentPassword"
                  type="password"
                  autocomplete="off"
                  :placeholder="$t('please_enter_your_current_password')"
                />
              </el-form-item>
              <el-form-item :label="$t('new_password')" prop="newPassword">
                <el-input
                  v-model="loginPasswordFormData.newPassword"
                  type="password"
                  autocomplete="off"
                  :placeholder="$t('please_enter_your_new_password')"
                />
              </el-form-item>
              <el-form-item
                :label="$t('confirm_password')"
                prop="confirmPassword"
              >
                <el-input
                  v-model="loginPasswordFormData.confirmPassword"
                  type="password"
                  autocomplete="off"
                  :placeholder="$t('please_confirm_new_password')"
                />
              </el-form-item>
              <el-form-item>
                <el-button
                  :disabled="isLoginPassProccessing"
                  type="primary"
                  round
                  class="w-[120px] !px-4 !py-2"
                  @click="changeLoginPassword(ruleLoginPasswordFormRef)"
                  >{{ $t("submit") }}</el-button
                >
              </el-form-item>
            </el-form>
          </div>
          <div class="w-5/12">
            <ul class="px-4 pb-4 space-y-2 text-sm rounded --text4">
              <h5 class="--text4">{{ $t("SBOKH_password_policy") }}</h5>
              <li class="font-normal">
                -
                {{
                  $t(
                    "password_must_contain_8_or_more_characters_with_a_mix_of_letters_number_and_symbols"
                  )
                }}
              </li>
              <li class="font-normal">
                - {{ $t("new_password_must_not_be_the_same_as_old_password") }}
              </li>
              <li class="font-normal">
                - {{ $t("confirm_password_must_be_the_same_as_new_password") }}
              </li>
            </ul>
          </div>
        </div>
      </div>
      <div
        v-if="isPaymentPasswordSet && isCashPlayer"
        class="space-y-4 p-6 password-item-container"
      >
        <h4>{{ $t("payment_password") }}</h4>
        <div class="flex space-x-2">
          <div class="w-7/12">
            <el-form
              ref="rulePaymentPasswordFormRef"
              label-position="left"
              :model="paymentPasswordFormData"
              status-icon
              :rules="paymentPasswordRules"
              label-width="150px"
              :validate-on-rule-change="false"
            >
              <el-form-item
                :label="$t('current_password')"
                prop="currentPassword"
              >
                <el-input
                  v-model="paymentPasswordFormData.currentPassword"
                  type="password"
                  autocomplete="off"
                  :placeholder="$t('please_enter_your_current_password')"
                />
              </el-form-item>
              <el-form-item :label="$t('new_password')" prop="newPassword">
                <el-input
                  v-model="paymentPasswordFormData.newPassword"
                  type="password"
                  autocomplete="off"
                  :placeholder="$t('please_enter_your_new_password')"
                />
              </el-form-item>
              <el-form-item
                :label="$t('confirm_password')"
                prop="confirmPassword"
              >
                <el-input
                  v-model="paymentPasswordFormData.confirmPassword"
                  type="password"
                  autocomplete="off"
                  :placeholder="$t('please_confirm_new_password')"
                />
              </el-form-item>
              <el-form-item>
                <el-button
                  :disabled="isPaymentPassProccessing"
                  type="primary"
                  round
                  class="w-[120px] !px-4 !py-2"
                  @click="changePaymentPassword(rulePaymentPasswordFormRef)"
                  >{{ $t("submit") }}</el-button
                >
              </el-form-item>
            </el-form>
          </div>
          <div class="w-5/12">
            <ul class="px-4 pb-4 space-y-2 text-sm rounded --text4">
              <h5 class="--text4">{{ $t("SBOKH_password_policy") }}</h5>
              <li class="font-normal">
                -
                {{
                  $t(
                    "payment_password_will_use_to_verify_your_identity_for_any_fund_related_operation_for_account_safety_purposes_please_enter_4_digits"
                  )
                }}
              </li>
              <li class="font-normal">
                - {{ $t("confirm_password_must_be_the_same_as_new_password") }}
              </li>
            </ul>
          </div>
        </div>
      </div>
      <div
        v-if="isLoginNameEnabled"
        class="p-6 space-y-4 password-item-container"
      >
        <h4>{{ $t("update_login_name") }}</h4>
        <div class="flex space-x-2">
          <div class="w-7/12">
            <el-form
              ref="ruleLoginNameFormRef"
              label-position="left"
              :model="loginNameFormData"
              :rules="loginNameRules"
              label-width="150px"
              :validate-on-rule-change="false"
            >
              <el-form-item :label="$t('new_login_name')" prop="newLoginName">
                <el-input
                  v-model="loginNameFormData.newLoginName"
                  autocomplete="off"
                />
              </el-form-item>
              <el-form-item>
                <el-button
                  :disabled="isLoginNameProccessing"
                  type="primary"
                  round
                  @click="changeLoginName(ruleLoginNameFormRef)"
                  >{{ $t("update_login_name") }}</el-button
                >
              </el-form-item>
            </el-form>
          </div>
          <div class="w-5/12">
            <ul class="px-4 pb-4 space-y-2 text-sm rounded --text4">
              <h5 class="--text4">{{ $t("login_name_policy") }}</h5>
              <li class="font-normal">- {{ $t("login_name_policy_1") }}</li>
              <li class="font-normal">- {{ $t("login_name_policy_2") }}</li>
              <li class="font-normal">- {{ $t("login_name_policy_3") }}</li>
            </ul>
          </div>
        </div>
      </div>
    </div>
    <el-dialog
      v-model="centerDialogVisible"
      width="30%"
      align-center
      :show-close="false"
      :title="$t('password_expired')"
    >
      <div class="w-full flex justify-center text-xl mb-2">
        <font-awesome-icon icon="lock" />
      </div>
      <span class="w-full flex justify-center">{{
        $t("please_change_new_password")
      }}</span>
      <template #footer>
        <span class="dialog-footer">
          <el-button
            type="primary"
            class="is-round"
            @click="centerDialogVisible = false"
          >
            {{ $t("okay") }}
          </el-button>
        </span>
      </template>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref } from "vue";
import { store } from "~~/store";

export default defineComponent({
  setup() {
    const themeName = store.state.selectedThemeName;
    const {
      ruleLoginPasswordFormRef,
      loginPasswordFormData,
      loginPasswordRules,
      changeLoginPassword,
      isLoginPassProccessing,
      isExpire,
    } = useLoginPassword();
    const {
      rulePaymentPasswordFormRef,
      paymentPasswordFormData,
      isPaymentPassProccessing,
      paymentPasswordRules,
      changePaymentPassword,
      isPaymentPasswordSet,
      isCashPlayer,
    } = usePaymentPassword();
    const {
      isLoginNameEnabled,
      loginNameFormData,
      loginNameRules,
      isLoginNameProcessing,
      changeLoginName,
      ruleLoginNameFormRef,
    } = useLoginName();
    const centerDialogVisible = ref(isExpire === "true");
    return {
      isLoginPassProccessing,
      isPaymentPassProccessing,
      isPaymentPasswordSet,
      ruleLoginPasswordFormRef,
      loginPasswordFormData,
      loginPasswordRules,
      changeLoginPassword,
      rulePaymentPasswordFormRef,
      paymentPasswordFormData,
      paymentPasswordRules,
      changePaymentPassword,
      isCashPlayer,
      centerDialogVisible,
      isLoginNameEnabled,
      loginNameFormData,
      loginNameRules,
      isLoginNameProcessing,
      changeLoginName,
      ruleLoginNameFormRef,
      themeName,
    };
  },
});
</script>
<style scoped>
:deep(.el-form-item__label) {
  color: var(--text5);
}
:deep(.el-input__inner) {
  background-color: var(--background5);
  color: var(--text5);
}
:deep(.el-input__inner::placeholder) {
  color: var(--text5);
  opacity: 0.5;
}
@media screen and (max-width: 639px) {
  :deep(.el-form-item) {
    display: block;
  }
  :deep(.el-form-item__content) {
    margin-left: 0 !important;
  }
}
</style>

<style lang="scss">
[theme-color="peru_green"] .password-peru .el-input__inner{
  font-weight: 400 !important;
}
.password-item-container {
  ul {
    list-style-position: inside;
  }
  
  li {
    text-indent: -7px;
  }
}
</style>
